
User Interface - Bug #2912

Bug # 2677 (New): fix drawing and functional differences between P2J GUI and 4GL GUI

alert-box is displayed on the task bar in Web GUI client, it shouldn't

12/03/2015 05:59 PM - Hynek Cihlar
Description

History

#1 - 12/04/2015 08:25 AM - Greg Shah

This only happens in the web client?

#2 - 12/04/2015 01:16 PM - Hynek Cihlar

Yes, this only happens in Web GUI.

#3 - 12/08/2015 01:27 PM - Greg Shah

- Start date deleted (12/03/2015)

- Assignee set to Sergey Ivanovskiy

- Target version set to Milestone 12

- Subject changed from Alert-box is displayed on the task bar in Web GUI client, it shouldn't to alert-box is displayed on the task bar in Web GUI client,

it shouldn't

#4 - 12/09/2015 09:07 AM - Sergey Ivanovskiy

Hynek, please log here what is a target program to reproduce this bug. For the JS client we can't distinguish modal windows from any other child

window. A task icon is created for a window and is displayed if its window becomes visible.

#5 - 12/09/2015 09:26 AM - Hynek Cihlar

Sergey Ivanovskiy wrote:

Hynek, please log here what is a target program to reproduce this bug. For the JS client we can't distinguish modal windows from any other child

window. A task icon is created for a window and is displayed if its window becomes visible.

 

Try simpler_alert_box.p for example. I guess we will have to extend the window info passed to JS client so it can identify modal windows.

#6 - 12/09/2015 12:26 PM - Sergey Ivanovskiy
Try simpler_alert_box.p for example. I guess we will have to extend the window info passed to JS client so it can identify modal windows.

 

I will try it but it needs global changes for GuiOutputManager to add void realizeModalWindow(int ownerId, int windowId, String windowTitle) and for

GuiDriver to add void registerModalWindow(ownerId, windowId, windowTitle) because of this code from ModalWindow.realize()

      screen().realizeChildWindow(ownerId, id.asInt(), title()); // we can't identify that this window is moda

l.

      realized = true;

      WindowManager.addWindow(this); // only after this code we can identify modal windows inside the web driv

er

#7 - 12/09/2015 12:34 PM - Sergey Ivanovskiy

No, there is the other way to use GuiDriver.setWindowVisible(true), because at that point we can identify the window is a modal one using

WindowManager.findWindow(int windowId).

#8 - 12/09/2015 12:42 PM - Hynek Cihlar

Sergey Ivanovskiy wrote:

Try simpler_alert_box.p for example. I guess we will have to extend the window info passed to JS client so it can identify modal windows.

 

I will try it but it needs global changes for GuiOutputManager to add void realizeModalWindow(int ownerId, int windowId, String windowTitle) and

for GuiDriver to add void registerModalWindow(ownerId, windowId, windowTitle) because of this code from ModalWindow.realize()

[...]

 

realizeChildWindow() returns a child top-level window. Although there isn't a formal javadoc that would define what is a child-window (I will add it), you

can assume that a child window is never shown on the "task bar". So the real key is not modality but the fact whether a window is a main or child

window. Note that currently any modal window is also a child window, but not in reverse - child window doesn't have to be necessary modal.
#9 - 12/09/2015 01:06 PM - Sergey Ivanovskiy

Hynek Cihlar wrote:

realizeChildWindow() returns a child top-level window. Although there isn't a formal javadoc that would define what is a child-window (I will add

it), you can assume that a child window is never shown on the "task bar". So the real key is not modality but the fact whether a window is a main

or child window. Note that currently any modal window is also a child window, but not in reverse - child window doesn't have to be necessary

modal.

 

You are right, it is a more simple solution and it doesn't require to change the web data protocol, since GuiDriver.registerChildWindow(int ownerId, int

windowId, String windowTitle) is used only by ModalWindow.

#10 - 12/09/2015 02:48 PM - Sergey Ivanovskiy

- File 10961.txt added

Greg, please review the committed rev 10961.

#11 - 12/12/2015 07:04 AM - Greg Shah

Code Review Task Branch 1811t Revision 10961

I'm fine with the changes.

Constantin: please review.

#12 - 12/14/2015 02:28 AM - Constantin Asofiei

Greg Shah wrote:

Code Review Task Branch 1811t Revision 10961

I'm fine with the changes.

Constantin: please review.

 

The changes look OK.

#13 - 12/14/2015 08:49 AM - Greg Shah
- % Done changed from 0 to 100

- Status changed from New to Closed

#14 - 11/16/2016 12:12 PM - Greg Shah

- Target version changed from Milestone 12 to GUI Support for a Complex ADM2 App

Files

10961.txt 3.88 KB 12/09/2015 Sergey Ivanovskiy
